(document:surround "/std/frame")
(document:insert "/std/functions")
(document:envelop with-translation _ "alterator-alternatives")

(frame:on-leave (lambda() (and (apply-button activity) 'need-confirm)))
(frame:on-apply (lambda() (write-alternatives)))

(define current-alternative (make-cell #f))
(define current-status (make-cell #f))

(define (alternatives)
  (woo-catch
   (thunk (woo-list-names "/alternatives"))
   (lambda(reason) '())))

(define (candidates a)
  (woo-catch
   (thunk (woo-list-names (string-append "/alternatives/"
                                         (string-drop a 1)
                                         "/candidates")))
   (lambda(reason) '())))

(define (alternative a)
  (woo-read-first (string-append "/alternatives/" a)))
                                                      
(define (ask-and-apply)
  (and (eq? 'yes (document:popup-warning
                  (_ "You have made some changes in alternative configuration
Do you want to apply your changes?")
                  'yes
                  'no))
       (write-alternatives))
  (apply-button inactive))

(define (write-alternatives)
  (woo-catch/message
   (thunk
    (woo-write/constraints (string-append "/alternatives/"
                                          (cell-ref current-alternative))
                           'current (candidateslist text)
                           'manual (manual state))
    (apply-button inactive)
    #t)))

(define (update-alternative-info)
  (let* ((name (alternativeslist text))
         (info (alternative name))
         (candidates (candidates name))
         (points (woo-get-option info 'current))
         (mode (woo-get-option info 'manual #f)))
    (cell-set! current-alternative name)
    (cell-set! current-status mode)
    (candidateslist rows candidates
                    current (string-list-index points candidates))
    (manual state mode)))

(groupbox (_ "Alternative")
          (vbox (document:id alternativeslist (listbox rows (alternatives)
                                                       (when selected
                                                         (and (apply-button activity) (ask-and-apply))
                                                         (update-alternative-info))))))
(groupbox (_ "Candidate")
          (document:id manual (checkbox (_ "manual setup") widget-name "manual"))
          (document:id candidateslist (listbox widget-name "current")))

(hbox
 (document:id apply-button (button (_ "Apply")
                                   inactive
                                   (when clicked (write-alternatives))))
 (button (_ "Quit") (when clicked (document:end))))
;;;;;;;;
(manual (when toggled
          (apply-button activity (not (eq? (cell-ref current-status)
                                           (manual state))))))
(candidateslist (when selected
                  (apply-button activity #t)))
(document:root
 (when loaded
   (update-constraints "write" "/alternatives")))

